
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Pyroute2 &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Changelog" href="changelog.html" />
    <link rel="prev" title="Pyroute2 netlink library" href="index.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="changelog.html" title="Changelog"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="index.html" title="Pyroute2 netlink library"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="pyroute2">
<h1>Pyroute2<a class="headerlink" href="#pyroute2" title="Permalink to this headline">¶</a></h1>
<p>Pyroute2 is a pure Python <strong>netlink</strong> library. The core requires only Python
stdlib, no 3rd party libraries. The library was started as an RTNL protocol
implementation, so the name is <strong>pyroute2</strong>, but now it supports many netlink
protocols. Some supported netlink families and protocols:</p>
<ul class="simple">
<li><p><strong>rtnl</strong>, network settings — addresses, routes, traffic controls</p></li>
<li><p><strong>nfnetlink</strong> — netfilter API</p></li>
<li><p><strong>ipq</strong> — simplest userspace packet filtering, iptables QUEUE target</p></li>
<li><p><strong>devlink</strong> — manage and monitor devlink-enabled hardware</p></li>
<li><p><strong>generic</strong> — generic netlink families</p></li>
<li><p><strong>uevent</strong> — same uevent messages as in udev</p></li>
</ul>
<p>Netfilter API:</p>
<ul class="simple">
<li><p><strong>ipset</strong> — IP sets</p></li>
<li><p><strong>nftables</strong> — packet filtering</p></li>
<li><p><strong>nfct</strong> — connection tracking</p></li>
</ul>
<p>Generic netlink:</p>
<ul class="simple">
<li><p><strong>ethtool</strong> — low-level network interface setup</p></li>
<li><p><strong>wireguard</strong> — VPN setup</p></li>
<li><p><strong>nl80211</strong> — wireless functions API (basic support)</p></li>
<li><p><strong>taskstats</strong> — extended process statistics</p></li>
<li><p><strong>acpi_events</strong> — ACPI events monitoring</p></li>
<li><p><strong>thermal_events</strong> — thermal events monitoring</p></li>
<li><p><strong>VFS_DQUOT</strong> — disk quota events monitoring</p></li>
</ul>
<p>On the low level the library provides socket objects with an
extended API. The additional functionality aims to:</p>
<ul class="simple">
<li><p>Help to open/bind netlink sockets</p></li>
<li><p>Discover generic netlink protocols and multicast groups</p></li>
<li><p>Construct, encode and decode netlink and PF_ROUTE messages</p></li>
</ul>
<div class="section" id="supported-systems">
<h2>Supported systems<a class="headerlink" href="#supported-systems" title="Permalink to this headline">¶</a></h2>
<p>Pyroute2 runs natively on Linux and emulates some limited subset
of RTNL netlink API on BSD systems on top of PF_ROUTE notifications
and standard system tools.</p>
<p>Other platforms are not supported.</p>
</div>
<div class="section" id="ndb-high-level-rtnl-api">
<h2>NDB – high level RTNL API<a class="headerlink" href="#ndb-high-level-rtnl-api" title="Permalink to this headline">¶</a></h2>
<p>Key features:</p>
<ul class="simple">
<li><p>Data integrity</p></li>
<li><p>Transactions with commit/rollback changes</p></li>
<li><p>State synchronization</p></li>
<li><p>Multiple sources, including netns and remote systems</p></li>
</ul>
<p>A “Hello world” example:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">NDB</span>

<span class="n">ndb</span> <span class="o">=</span> <span class="n">NDB</span><span class="p">(</span><span class="n">log</span><span class="o">=</span><span class="s1">&#39;on&#39;</span><span class="p">)</span>
<span class="k">for</span> <span class="n">record</span> <span class="ow">in</span> <span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">summary</span><span class="p">():</span>
    <span class="k">print</span><span class="p">(</span><span class="n">record</span><span class="o">.</span><span class="n">ifname</span><span class="p">,</span> <span class="n">record</span><span class="o">.</span><span class="n">address</span><span class="p">,</span> <span class="n">record</span><span class="o">.</span><span class="n">state</span><span class="p">)</span>

<span class="k">for</span> <span class="n">record</span> <span class="ow">in</span> <span class="n">ndb</span><span class="o">.</span><span class="n">addresses</span><span class="o">.</span><span class="n">summary</span><span class="p">():</span>
    <span class="k">print</span><span class="p">(</span><span class="n">record</span><span class="o">.</span><span class="n">_as_dict</span><span class="p">())</span>

<span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">interfaces</span>
 <span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;br0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;bridge&#39;</span><span class="p">)</span>  <span class="c1"># create a bridge</span>
 <span class="o">.</span><span class="n">add_port</span><span class="p">(</span><span class="s1">&#39;eth0&#39;</span><span class="p">)</span>                     <span class="c1"># add ports</span>
 <span class="o">.</span><span class="n">add_port</span><span class="p">(</span><span class="s1">&#39;eth1&#39;</span><span class="p">)</span>                     <span class="c1">#</span>
 <span class="o">.</span><span class="n">add_ip</span><span class="p">(</span><span class="s1">&#39;10.0.0.1/24&#39;</span><span class="p">)</span>                <span class="c1"># add addresses</span>
 <span class="o">.</span><span class="n">add_ip</span><span class="p">(</span><span class="s1">&#39;192.168.0.1/24&#39;</span><span class="p">)</span>             <span class="c1">#</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;br_stp_state&#39;</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>               <span class="c1"># set STP on</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;state&#39;</span><span class="p">,</span> <span class="s1">&#39;up&#39;</span><span class="p">)</span>                   <span class="c1"># bring the interface up</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>                            <span class="c1"># commit pending changes</span>
</pre></div>
</div>
</div>
<div class="section" id="iproute-low-level-rtnl-api">
<h2>IPRoute – Low level RTNL API<a class="headerlink" href="#iproute-low-level-rtnl-api" title="Permalink to this headline">¶</a></h2>
<p>Low-level <strong>IPRoute</strong> utility — Linux network configuration.
The <strong>IPRoute</strong> class is a 1-to-1 RTNL mapping. There are no implicit
interface lookups and so on.</p>
<p>Get notifications about network settings changes with IPRoute:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">IPRoute</span>
<span class="k">with</span> <span class="n">IPRoute</span><span class="p">()</span> <span class="k">as</span> <span class="n">ipr</span><span class="p">:</span>
    <span class="c1"># With IPRoute objects you have to call bind() manually</span>
    <span class="n">ipr</span><span class="o">.</span><span class="n">bind</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">message</span> <span class="ow">in</span> <span class="n">ipr</span><span class="o">.</span><span class="n">get</span><span class="p">():</span>
        <span class="k">print</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>
</pre></div>
</div>
<p>More examples:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">socket</span> <span class="kn">import</span> <span class="n">AF_INET</span>
<span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">IPRoute</span>

<span class="c1"># get access to the netlink socket</span>
<span class="n">ip</span> <span class="o">=</span> <span class="n">IPRoute</span><span class="p">()</span>
<span class="c1"># no monitoring here -- thus no bind()</span>

<span class="c1"># print interfaces</span>
<span class="k">for</span> <span class="n">link</span> <span class="ow">in</span> <span class="n">ip</span><span class="o">.</span><span class="n">get_links</span><span class="p">():</span>
    <span class="k">print</span><span class="p">(</span><span class="n">link</span><span class="p">)</span>

<span class="c1"># create VETH pair and move v0p1 to netns &#39;test&#39;</span>
<span class="n">ip</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;add&#39;</span><span class="p">,</span> <span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">,</span> <span class="n">peer</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;veth&#39;</span><span class="p">)</span>
<span class="n">idx</span> <span class="o">=</span> <span class="n">ip</span><span class="o">.</span><span class="n">link_lookup</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">ip</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;set&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="n">idx</span><span class="p">,</span> <span class="n">net_ns_fd</span><span class="o">=</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>

<span class="c1"># bring v0p0 up and add an address</span>
<span class="n">idx</span> <span class="o">=</span> <span class="n">ip</span><span class="o">.</span><span class="n">link_lookup</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">ip</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;set&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="n">idx</span><span class="p">,</span> <span class="n">state</span><span class="o">=</span><span class="s1">&#39;up&#39;</span><span class="p">)</span>
<span class="n">ip</span><span class="o">.</span><span class="n">addr</span><span class="p">(</span><span class="s1">&#39;add&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="n">idx</span><span class="p">,</span> <span class="n">address</span><span class="o">=</span><span class="s1">&#39;10.0.0.1&#39;</span><span class="p">,</span> <span class="n">prefixlen</span><span class="o">=</span><span class="mi">24</span><span class="p">)</span>

<span class="c1"># release Netlink socket</span>
<span class="n">ip</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="section" id="network-namespace-examples">
<h2>Network namespace examples<a class="headerlink" href="#network-namespace-examples" title="Permalink to this headline">¶</a></h2>
<p>Network namespace manipulation:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">netns</span>
<span class="c1"># create netns</span>
<span class="n">netns</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
<span class="c1"># list</span>
<span class="k">print</span><span class="p">(</span><span class="n">netns</span><span class="o">.</span><span class="n">listnetns</span><span class="p">())</span>
<span class="c1"># remove netns</span>
<span class="n">netns</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>Create <strong>veth</strong> interfaces pair and move to <strong>netns</strong>:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">IPRoute</span>

<span class="k">with</span> <span class="n">IPRoute</span><span class="p">()</span> <span class="k">as</span> <span class="n">ipr</span><span class="p">:</span>

    <span class="c1"># create interface pair</span>
    <span class="n">ipr</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;add&#39;</span><span class="p">,</span> <span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;veth&#39;</span><span class="p">,</span>  <span class="n">peer</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)</span>

    <span class="c1"># lookup the peer index</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">ipr</span><span class="o">.</span><span class="n">link_lookup</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>

    <span class="c1"># move the peer to the &#39;test&#39; netns:</span>
    <span class="n">ipr</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;set&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">,</span> <span class="n">net_ns_fd</span><span class="o">=</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>List interfaces in some <strong>netns</strong>:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="kn">import</span> <span class="n">NetNS</span>
<span class="kn">from</span> <span class="nn">pprint</span> <span class="kn">import</span> <span class="n">pprint</span>

<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
<span class="n">pprint</span><span class="p">(</span><span class="n">ns</span><span class="o">.</span><span class="n">get_links</span><span class="p">())</span>
<span class="n">ns</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
</pre></div>
</div>
<p>More details and samples see in the documentation.</p>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<p><cite>make install</cite> or <cite>pip install pyroute2</cite></p>
</div>
<div class="section" id="requirements">
<h2>Requirements<a class="headerlink" href="#requirements" title="Permalink to this headline">¶</a></h2>
<p>Python &gt;= 2.7</p>
<p>The pyroute2 testing and documentaion framework requirements:</p>
<ul class="simple">
<li><p>flake8</p></li>
<li><p>coverage</p></li>
<li><p>nosetests</p></li>
<li><p>sphinx</p></li>
<li><p>aafigure</p></li>
<li><p>netaddr</p></li>
<li><p>dtcd (optional, <a class="reference external" href="https://github.com/svinota/dtcd">https://github.com/svinota/dtcd</a>)</p></li>
</ul>
<p>Optional dependencies:</p>
<ul class="simple">
<li><p>mitogen – for distributed rtnl</p></li>
<li><p>psutil – for ss2 tool</p></li>
</ul>
</div>
<div class="section" id="links">
<h2>Links<a class="headerlink" href="#links" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>home: <a class="reference external" href="https://pyroute2.org/">https://pyroute2.org/</a></p></li>
<li><p>srcs: <a class="reference external" href="https://github.com/svinota/pyroute2">https://github.com/svinota/pyroute2</a></p></li>
<li><p>bugs: <a class="reference external" href="https://github.com/svinota/pyroute2/issues">https://github.com/svinota/pyroute2/issues</a></p></li>
<li><p>pypi: <a class="reference external" href="https://pypi.python.org/pypi/pyroute2">https://pypi.python.org/pypi/pyroute2</a></p></li>
<li><p>docs: <a class="reference external" href="http://docs.pyroute2.org/">http://docs.pyroute2.org/</a></p></li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Pyroute2</a><ul>
<li><a class="reference internal" href="#supported-systems">Supported systems</a></li>
<li><a class="reference internal" href="#ndb-high-level-rtnl-api">NDB – high level RTNL API</a></li>
<li><a class="reference internal" href="#iproute-low-level-rtnl-api">IPRoute – Low level RTNL API</a></li>
<li><a class="reference internal" href="#network-namespace-examples">Network namespace examples</a></li>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#requirements">Requirements</a></li>
<li><a class="reference internal" href="#links">Links</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="index.html"
                        title="previous chapter">Pyroute2 netlink library</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="changelog.html"
                        title="next chapter">Changelog</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/general.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="changelog.html" title="Changelog"
             >next</a> |</li>
        <li class="right" >
          <a href="index.html" title="Pyroute2 netlink library"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>